unit UchilkaUnit;

interface

uses
  SysUtils, 
  Generics.Collections, 
  Aurelius.Mapping.Attributes, 
  Aurelius.Types.Blob, 
  Aurelius.Types.DynamicProperties, 
  Aurelius.Types.Nullable, 
  Aurelius.Types.Proxy, 
  Aurelius.Criteria.Dictionary;

type
  Tgroup_tasks = class;
  Treg = class;
  Ttasks = class;
  Ttype_of_grp = class;
  Tgroup_tasksTableDictionary = class;
  TregTableDictionary = class;
  TtasksTableDictionary = class;
  Ttype_of_grpTableDictionary = class;
  
  [Entity]
  [Table('group_tasks')]
  [Sequence('group_tasks_grp_id_seq')]
  [Id('Fgrp_id', TIdGenerator.IdentityOrSequence)]
  Tgroup_tasks = class
  private
    [Column('grp_id', [TColumnProp.Required])]
    Fgrp_id: Integer;
    
    [Column('grp_name', [], 100)]
    Fgrp_name: Nullable<string>;
    
    [Column('grp_desc', [], 100)]
    Fgrp_desc: Nullable<string>;
    
    [Association([TAssociationProp.Lazy], CascadeTypeAll - [TCascadeType.Remove])]
    [JoinColumn('user_id', [], 'user_id')]
    Fuser: Proxy<Treg>;
    
    [Association([TAssociationProp.Lazy], CascadeTypeAll - [TCascadeType.Remove])]
    [JoinColumn('type_id', [], 'type_id')]
    Ftype_id: Proxy<Ttype_of_grp>;
    function Getuser: Treg;
    procedure Setuser(const Value: Treg);
    function Gettype_id: Ttype_of_grp;
    procedure Settype_id(const Value: Ttype_of_grp);
  public
    property grp_id: Integer read Fgrp_id write Fgrp_id;
    property grp_name: Nullable<string> read Fgrp_name write Fgrp_name;
    property grp_desc: Nullable<string> read Fgrp_desc write Fgrp_desc;
    property user: Treg read Getuser write Setuser;
    property type_id: Ttype_of_grp read Gettype_id write Settype_id;
  end;
  
  [Entity]
  [Table('reg')]
  [Sequence('reg_user_id_seq')]
  [Id('Fuser_id', TIdGenerator.IdentityOrSequence)]
  Treg = class
  private
    [Column('user_id', [TColumnProp.Required])]
    Fuser_id: Integer;
    
    [Column('phone', [], 0, 0)]
    Fphone: Nullable<Double>;
    
    [Column('pass', [], 100)]
    Fpass: Nullable<string>;
    
    [Column('fio', [], 100)]
    Ffio: Nullable<string>;
  public
    property user_id: Integer read Fuser_id write Fuser_id;
    property phone: Nullable<Double> read Fphone write Fphone;
    property pass: Nullable<string> read Fpass write Fpass;
    property fio: Nullable<string> read Ffio write Ffio;
  end;
  
  [Entity]
  [Table('tasks')]
  [Sequence('tasks_task_id_seq')]
  [Id('Ftask_id', TIdGenerator.IdentityOrSequence)]
  Ttasks = class
  private
    [Column('task_id', [TColumnProp.Required])]
    Ftask_id: Integer;
    
    [Column('num', [])]
    Fnum: Nullable<Integer>;
    
    [Column('question', [], 200)]
    Fquestion: Nullable<string>;
    
    [Column('answer1', [], 200)]
    Fanswer1: Nullable<string>;
    
    [Column('answer2', [], 200)]
    Fanswer2: Nullable<string>;
    
    [Column('answer3', [], 200)]
    Fanswer3: Nullable<string>;
    
    [Column('answer4', [], 200)]
    Fanswer4: Nullable<string>;
    
    [Column('answer5', [], 200)]
    Fanswer5: Nullable<string>;
    
    [Column('answer6', [], 200)]
    Fanswer6: Nullable<string>;
    
    [Column('answtrue1', [], 200)]
    Fanswtrue1: Nullable<string>;
    
    [Column('answtrue2', [], 200)]
    Fanswtrue2: Nullable<string>;
    
    [Column('answtrue3', [], 200)]
    Fanswtrue3: Nullable<string>;
    
    [Column('answtrue4', [], 200)]
    Fanswtrue4: Nullable<string>;
    
    [Column('answtrue5', [], 200)]
    Fanswtrue5: Nullable<string>;
    
    [Column('answtrue6', [], 200)]
    Fanswtrue6: Nullable<string>;
    
    [Column('pic', [TColumnProp.Lazy])]
    Fpic: TBlob;
    
    [Association([TAssociationProp.Lazy], CascadeTypeAll - [TCascadeType.Remove])]
    [JoinColumn('grp_id', [], 'grp_id')]
    Fgrp: Proxy<Tgroup_tasks>;
    function Getgrp: Tgroup_tasks;
    procedure Setgrp(const Value: Tgroup_tasks);
  public
    property task_id: Integer read Ftask_id write Ftask_id;
    property num: Nullable<Integer> read Fnum write Fnum;
    property question: Nullable<string> read Fquestion write Fquestion;
    property answer1: Nullable<string> read Fanswer1 write Fanswer1;
    property answer2: Nullable<string> read Fanswer2 write Fanswer2;
    property answer3: Nullable<string> read Fanswer3 write Fanswer3;
    property answer4: Nullable<string> read Fanswer4 write Fanswer4;
    property answer5: Nullable<string> read Fanswer5 write Fanswer5;
    property answer6: Nullable<string> read Fanswer6 write Fanswer6;
    property answtrue1: Nullable<string> read Fanswtrue1 write Fanswtrue1;
    property answtrue2: Nullable<string> read Fanswtrue2 write Fanswtrue2;
    property answtrue3: Nullable<string> read Fanswtrue3 write Fanswtrue3;
    property answtrue4: Nullable<string> read Fanswtrue4 write Fanswtrue4;
    property answtrue5: Nullable<string> read Fanswtrue5 write Fanswtrue5;
    property answtrue6: Nullable<string> read Fanswtrue6 write Fanswtrue6;
    property pic: TBlob read Fpic write Fpic;
    property grp: Tgroup_tasks read Getgrp write Setgrp;
  end;
  
  [Entity]
  [Table('type_of_grp')]
  [Sequence('type_of_grp_type_id_seq')]
  [Id('Ftype_id', TIdGenerator.IdentityOrSequence)]
  Ttype_of_grp = class
  private
    [Column('type_id', [TColumnProp.Required])]
    Ftype_id: Integer;
    
    [Column('type_name', [], 100)]
    Ftype_name: Nullable<string>;
  public
    property type_id: Integer read Ftype_id write Ftype_id;
    property type_name: Nullable<string> read Ftype_name write Ftype_name;
  end;
  
  TDicDictionary = class
  private
    Fgroup_tasks: Tgroup_tasksTableDictionary;
    Freg: TregTableDictionary;
    Ftasks: TtasksTableDictionary;
    Ftype_of_grp: Ttype_of_grpTableDictionary;
    function Getgroup_tasks: Tgroup_tasksTableDictionary;
    function Getreg: TregTableDictionary;
    function Gettasks: TtasksTableDictionary;
    function Gettype_of_grp: Ttype_of_grpTableDictionary;
  public
    destructor Destroy; override;
    property group_tasks: Tgroup_tasksTableDictionary read Getgroup_tasks;
    property reg: TregTableDictionary read Getreg;
    property tasks: TtasksTableDictionary read Gettasks;
    property type_of_grp: Ttype_of_grpTableDictionary read Gettype_of_grp;
  end;
  
  Tgroup_tasksTableDictionary = class
  private
    Fgrp_id: TDictionaryAttribute;
    Fgrp_name: TDictionaryAttribute;
    Fgrp_desc: TDictionaryAttribute;
    Fuser: TDictionaryAssociation;
    Ftype_id: TDictionaryAssociation;
  public
    constructor Create;
    property grp_id: TDictionaryAttribute read Fgrp_id;
    property grp_name: TDictionaryAttribute read Fgrp_name;
    property grp_desc: TDictionaryAttribute read Fgrp_desc;
    property user: TDictionaryAssociation read Fuser;
    property type_id: TDictionaryAssociation read Ftype_id;
  end;
  
  TregTableDictionary = class
  private
    Fuser_id: TDictionaryAttribute;
    Fphone: TDictionaryAttribute;
    Fpass: TDictionaryAttribute;
    Ffio: TDictionaryAttribute;
  public
    constructor Create;
    property user_id: TDictionaryAttribute read Fuser_id;
    property phone: TDictionaryAttribute read Fphone;
    property pass: TDictionaryAttribute read Fpass;
    property fio: TDictionaryAttribute read Ffio;
  end;
  
  TtasksTableDictionary = class
  private
    Ftask_id: TDictionaryAttribute;
    Fnum: TDictionaryAttribute;
    Fquestion: TDictionaryAttribute;
    Fanswer1: TDictionaryAttribute;
    Fanswer2: TDictionaryAttribute;
    Fanswer3: TDictionaryAttribute;
    Fanswer4: TDictionaryAttribute;
    Fanswer5: TDictionaryAttribute;
    Fanswer6: TDictionaryAttribute;
    Fanswtrue1: TDictionaryAttribute;
    Fanswtrue2: TDictionaryAttribute;
    Fanswtrue3: TDictionaryAttribute;
    Fanswtrue4: TDictionaryAttribute;
    Fanswtrue5: TDictionaryAttribute;
    Fanswtrue6: TDictionaryAttribute;
    Fpic: TDictionaryAttribute;
    Fgrp: TDictionaryAssociation;
  public
    constructor Create;
    property task_id: TDictionaryAttribute read Ftask_id;
    property num: TDictionaryAttribute read Fnum;
    property question: TDictionaryAttribute read Fquestion;
    property answer1: TDictionaryAttribute read Fanswer1;
    property answer2: TDictionaryAttribute read Fanswer2;
    property answer3: TDictionaryAttribute read Fanswer3;
    property answer4: TDictionaryAttribute read Fanswer4;
    property answer5: TDictionaryAttribute read Fanswer5;
    property answer6: TDictionaryAttribute read Fanswer6;
    property answtrue1: TDictionaryAttribute read Fanswtrue1;
    property answtrue2: TDictionaryAttribute read Fanswtrue2;
    property answtrue3: TDictionaryAttribute read Fanswtrue3;
    property answtrue4: TDictionaryAttribute read Fanswtrue4;
    property answtrue5: TDictionaryAttribute read Fanswtrue5;
    property answtrue6: TDictionaryAttribute read Fanswtrue6;
    property pic: TDictionaryAttribute read Fpic;
    property grp: TDictionaryAssociation read Fgrp;
  end;
  
  Ttype_of_grpTableDictionary = class
  private
    Ftype_id: TDictionaryAttribute;
    Ftype_name: TDictionaryAttribute;
  public
    constructor Create;
    property type_id: TDictionaryAttribute read Ftype_id;
    property type_name: TDictionaryAttribute read Ftype_name;
  end;
  
function Dic: TDicDictionary;

implementation

var
  __Dic: TDicDictionary;

function Dic: TDicDictionary;
begin
  if __Dic = nil then __Dic := TDicDictionary.Create;
  result := __Dic
end;

{ Tgroup_tasks }

function Tgroup_tasks.Getuser: Treg;
begin
  result := Fuser.Value;
end;

procedure Tgroup_tasks.Setuser(const Value: Treg);
begin
  Fuser.Value := Value;
end;

function Tgroup_tasks.Gettype_id: Ttype_of_grp;
begin
  result := Ftype_id.Value;
end;

procedure Tgroup_tasks.Settype_id(const Value: Ttype_of_grp);
begin
  Ftype_id.Value := Value;
end;

{ Ttasks }

function Ttasks.Getgrp: Tgroup_tasks;
begin
  result := Fgrp.Value;
end;

procedure Ttasks.Setgrp(const Value: Tgroup_tasks);
begin
  Fgrp.Value := Value;
end;

{ TDicDictionary }

destructor TDicDictionary.Destroy;
begin
  if Ftype_of_grp <> nil then Ftype_of_grp.Free;
  if Ftasks <> nil then Ftasks.Free;
  if Freg <> nil then Freg.Free;
  if Fgroup_tasks <> nil then Fgroup_tasks.Free;
  inherited;
end;

function TDicDictionary.Getgroup_tasks: Tgroup_tasksTableDictionary;
begin
  if Fgroup_tasks = nil then Fgroup_tasks := Tgroup_tasksTableDictionary.Create;
  result := Fgroup_tasks;
end;

function TDicDictionary.Getreg: TregTableDictionary;
begin
  if Freg = nil then Freg := TregTableDictionary.Create;
  result := Freg;
end;

function TDicDictionary.Gettasks: TtasksTableDictionary;
begin
  if Ftasks = nil then Ftasks := TtasksTableDictionary.Create;
  result := Ftasks;
end;

function TDicDictionary.Gettype_of_grp: Ttype_of_grpTableDictionary;
begin
  if Ftype_of_grp = nil then Ftype_of_grp := Ttype_of_grpTableDictionary.Create;
  result := Ftype_of_grp;
end;

{ Tgroup_tasksTableDictionary }

constructor Tgroup_tasksTableDictionary.Create;
begin
  inherited;
  Fgrp_id := TDictionaryAttribute.Create('grp_id');
  Fgrp_name := TDictionaryAttribute.Create('grp_name');
  Fgrp_desc := TDictionaryAttribute.Create('grp_desc');
  Fuser := TDictionaryAssociation.Create('user');
  Ftype_id := TDictionaryAssociation.Create('type_id');
end;

{ TregTableDictionary }

constructor TregTableDictionary.Create;
begin
  inherited;
  Fuser_id := TDictionaryAttribute.Create('user_id');
  Fphone := TDictionaryAttribute.Create('phone');
  Fpass := TDictionaryAttribute.Create('pass');
  Ffio := TDictionaryAttribute.Create('fio');
end;

{ TtasksTableDictionary }

constructor TtasksTableDictionary.Create;
begin
  inherited;
  Ftask_id := TDictionaryAttribute.Create('task_id');
  Fnum := TDictionaryAttribute.Create('num');
  Fquestion := TDictionaryAttribute.Create('question');
  Fanswer1 := TDictionaryAttribute.Create('answer1');
  Fanswer2 := TDictionaryAttribute.Create('answer2');
  Fanswer3 := TDictionaryAttribute.Create('answer3');
  Fanswer4 := TDictionaryAttribute.Create('answer4');
  Fanswer5 := TDictionaryAttribute.Create('answer5');
  Fanswer6 := TDictionaryAttribute.Create('answer6');
  Fanswtrue1 := TDictionaryAttribute.Create('answtrue1');
  Fanswtrue2 := TDictionaryAttribute.Create('answtrue2');
  Fanswtrue3 := TDictionaryAttribute.Create('answtrue3');
  Fanswtrue4 := TDictionaryAttribute.Create('answtrue4');
  Fanswtrue5 := TDictionaryAttribute.Create('answtrue5');
  Fanswtrue6 := TDictionaryAttribute.Create('answtrue6');
  Fpic := TDictionaryAttribute.Create('pic');
  Fgrp := TDictionaryAssociation.Create('grp');
end;

{ Ttype_of_grpTableDictionary }

constructor Ttype_of_grpTableDictionary.Create;
begin
  inherited;
  Ftype_id := TDictionaryAttribute.Create('type_id');
  Ftype_name := TDictionaryAttribute.Create('type_name');
end;

initialization
  RegisterEntity(Tgroup_tasks);
  RegisterEntity(Treg);
  RegisterEntity(Ttasks);
  RegisterEntity(Ttype_of_grp);

finalization
  if __Dic <> nil then __Dic.Free

end.
